<?php

/**
 * ownCloud - Documents App
 *
 * @author Victor Dubiniuk
 * @copyright 2013 Victor Dubiniuk victor.dubiniuk@gmail.com
 *
 * This file is licensed under the Affero General Public License version 3 or
 * later.
 */

namespace OCA\Documents;

class DocumentController extends Controller{
	const ODT_TEMPLATE = '[encoded data, 11648 characters]';
	
	public static function create($args){
		$uid = self::preDispatch();
		
		$view = new \OC\Files\View('/' . $uid . '/files');
		
		$dir = \OCP\Config::getUserValue(\OCP\User::getUser(), 'documents', 'save_path', '/');
		$path = Helper::getNewFileName($view, $dir . '/New Document.odt');
		
		$content = base64_decode(self::ODT_TEMPLATE);
		if (class_exists('\OC\Files\Type\TemplateManager')){
			$manager = \OC_Helper::getFileTemplateManager();
			$templateContent = $manager->getTemplate(Storage::MIMETYPE_LIBREOFFICE_WORDPROCESSOR);
			if ($templateContent){
				$content = $templateContent;
			}
		}
		
		$view->file_put_contents($path, $content);
	}


	/**
	 * Process partial/complete file download
	 * @param array $args - array containing session id as an element with a key es_id 
	 */
	public static function serve($args){
		$session = new Db_Session();
		$sessionData = $session->load(@$args['es_id'])->getData();
			
		$file = new File(@$sessionData['file_id']);
		if (!$file->isPublicShare()){
			self::preDispatch(false);
		} else {
			self::preDispatchGuest(false);
		}
		
		$filename = isset($sessionData['genesis_url']) ? $sessionData['genesis_url'] : '';
		$download = new Download($sessionData['owner'], $filename);
		$download->sendResponse();
	}
	

	public static function rename($args){
		$fileId = intval(@$args['file_id']);
		$name = @$_POST['name'];
		$file = new File($fileId);
		$l = new \OC_L10n('documents');

		if (isset($name) && $file->getPermissions() & \OCP\PERMISSION_UPDATE) {
			if ($file->renameTo($name)) {
				// TODO: propagate to other clients
				\OCP\JSON::success();
				return;
			}
		}
		\OCP\JSON::error(array(
			'message' => $l->t('You don\'t have permission to rename this document')
		));
	}

	/**
	 * lists the documents the user has access to (including shared files, once the code in core has been fixed)
	 * also adds session and member info for these files
	 */
	public static function listAll(){
		self::preDispatch();
		
		$documents = Storage::getDocuments();

		$fileIds = array();
		
		//$previewAvailable = \OCP\Preview::show($file);
		foreach ($documents as $key=>$document) {
			//\OCP\Preview::show($document['path']);
			$documents[$key]['icon'] = preg_replace('/\.png$/', '.svg', \OC_Helper::mimetypeIcon($document['mimetype']));
			$fileIds[] = $document['fileid'];
		}

		usort($documents, function($a, $b){
			return @$b['mtime']-@$a['mtime'];
		});
		
		$session = new Db_Session();
		$sessions = $session->getCollectionBy('file_id', $fileIds);

		$members = array();
		$member = new Db_Member();
		foreach ($sessions as $session) {			
			$members[$session['es_id']] = $member->getActiveCollection($session['es_id']);
		}

		\OCP\JSON::success(array('documents' => $documents,'sessions' => $sessions,'members' => $members));
	}
}
